<?php
	/**
	* Inter module data linking manager for phpGroupWare
	*
	* @author Dave Hall <skwashd@phpgroupware.org>
	* @copyright (c) 2007 Dave Hall http://davehall.com.au
	* @license http://www.gnu.org/licenses/gpl.html GNU General Public License Version 3 or later
	* @version $Id$
	* @package phpgwapi
	* @subpackage linking
	*/

	/*
		This program is free software: you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation, either version 3 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/**
	* Inter module data linking manager for phpGroupWare
	*
	* @package phpgwapi
	* @subpackage linking
	*/
	class phpgw_interlink
	{
		/**
		* @var object $db reference to global db object
		*/
		private $db;

		/**
		* Constructor
		*/
		public function __construct()
		{}

		/**
		* Add a link
		*
		* @param string $app1 the first application (usually the source)
		* @param string $class1 the first class
		* @param int $id1 the first record id
		* @param string $app2 the second application (usually the target)
		* @param string $class2 the second class
		* @param int $id2 the second record id
		* @param bool $private is the link private
		* @return int the new link id, or 0 on failure
		*/
		public function add_link($app1, $class1,  $id1, $app2, $class2, $id2, $private = true)
		{}

		/**
		* Count the number of records linked to a record
		*
		* @internal this should be called before deleting a record to ensure orphaned links aren't created
		* @param string $app the module to link to
		* @param string $clss the class to link to
		* @param int $id the id to link to
		* @return int the number of links found
		*/
		public function count_links($app, $clss, $id)
		{}

		/**
		* Delete a link
		*
		* @param int $link_id the link to delete
		* @return bool was the link deleted?
		*/
		public function delete_link($link_id)
		{}

		/**
		* List available links
		*
		* @param string $app the module to link to
		* @param string $clss the class to link to
		* @param int $id the id to link to
		* @return array list of links in the following format - ['link_id'] = array('app' => 'string', 'summary' => 'string', 'account_id' => int, 'view' => 'string', 'edit' => 'string')
		*/
		public function list_links($app, $clss, $id)
		{}
	}
